// TrackerScriptEditorWindow.cpp
// Generated by Interface Elements (Window v2.0) on Apr 25 1998
// This is a user written class and will not be overwritten.

#include "TrackerScriptEditorWindow.h"
#include <kernel/fs_attr.h>
#include <string.h>

TrackerScriptEditorWindow::TrackerScriptEditorWindow(const entry_ref *e)
	: IEWindow("TrackerScript editor window"), entry(*e)
{
	Lock();
	Load();
	AddShortcut('a',B_COMMAND_KEY,new BMessage(B_ABOUT_REQUESTED));
	Unlock();
}

void TrackerScriptEditorWindow::Load()
{
	BNode this_node(&entry);
	attr_info info;
	status_t ret;
	
	// load the script
	ret=this_node.GetAttrInfo("script",&info);
	if (ret==B_OK && info.type==B_STRING_TYPE) {
		char* s = new char[info.size+1];
		this_node.ReadAttr("script", B_STRING_TYPE, 0, s, info.size);
		((BTextView *)FindView("script"))->SetText(s);
		delete[] s;
	} else ((BTextView *)FindView("script"))->SetText(
"#your script goes here\n"
"for i in \"$@\"\n"
"    do listattr \"$i\"\n"
"done\n"
"read #Wait for the user to type <return> if \"View output\" is selected.\n"
"\n"
"#Hints:\n"
"#  You can't specify a different interpreter.  Try something like:\n"
"#         exec /usr/local/bin/perl <<'ASDF'\n"
"#            print \"hello, world!\\n\"; $_=<>;\n"
"#         ASDF\n"
"#      instead.\n"
"#  Use 'Here Doc' (<<'ASDF') syntax to run commands with input.\n"
"#  Paths to selected files are given to you as $[1-9]+.\n"
"#  Learn about \"$*\" vs \"$@\" vs $* vs $@\n"
"#  This script is passed as an argument (sh -c) so it can't be too big.\n"
"#      Break it out into a separate file if that's a problem, or you don't\n"
"#      want to lose it in a database rebuild.\n"
"#  If the Terminal window mysteriously vanishes before you have a chance\n"
"#      to read it, you're probably making a syntax error.  Try running\n"
"#      the script in a subshell (sh -s <<'ASDF')"
	);
	
	
	// view the output in a Terminal?
	ret=this_node.GetAttrInfo("terminal",&info);
	if (ret==B_OK && info.type==B_INT32_TYPE) {
		int32 b;
		this_node.ReadAttr("terminal", B_INT32_TYPE, 0, &b, sizeof(b));
		((BCheckBox *)FindView("terminal"))->SetValue(b);
	} else ((BCheckBox *)FindView("terminal"))->SetValue(false);

}

void TrackerScriptEditorWindow::Save()
{
	// save command and script to attributes
	BNode node(&entry);
	const char *text;
	status_t ret;
	
	text=((BTextView *)FindView("script"))->Text();
	ret=node.WriteAttr("script",B_STRING_TYPE,0,text,strlen(text)+1);
	if (ret<B_OK) {
		BAlert *alert=new BAlert(
			"Script not saved:",
			strerror(ret),
			"Oops!",
			0,0,
			B_WIDTH_AS_USUAL,
			B_STOP_ALERT);
		alert->Go();
	}
	
	int32 value=((BCheckBox *)FindView("terminal"))->Value();
	ret=node.WriteAttr("terminal",B_INT32_TYPE,0,&value,sizeof(value));
	if (ret<B_OK) {
		BAlert *alert=new BAlert(
			"Script not saved:",
			strerror(ret),
			"Oops!",
			0,0,
			B_WIDTH_AS_USUAL,
			B_STOP_ALERT);
		alert->Go();
	}
}

TrackerScriptEditorWindow::~TrackerScriptEditorWindow(void)
{
}

bool TrackerScriptEditorWindow::QuitRequested()
{
	Save();
	if (be_app->CountWindows()<=1)
		be_app->PostMessage(B_QUIT_REQUESTED);
	return(TRUE);
}

void TrackerScriptEditorWindow::MessageReceived(BMessage *message)
{
	if (message->what == B_ABOUT_REQUESTED)
		be_app->PostMessage(B_ABOUT_REQUESTED);
	else if (message->what == 'LOAD') Load();
	else if (message->what == B_SAVE_REQUESTED) Save();
	else IEWindow::MessageReceived(message);
}
